"use strict";

const assureArray = require("assure-array");

function objectifyUrl(url) {
	if (typeof url === "string") {
		return { url: url };
	} else {
		return url;
	}
}

module.exports = function normalizeUrls(urls, {parentUrl} = {}) {
	if (urls == null) {
		return [];
	} else {
		return assureArray(urls).map((url) => {
			let urlObject = objectifyUrl(url);

			if (parentUrl != null) {
				urlObject.depth = (urlObject.sameDepth)
					? parentUrl.depth
					: parentUrl.depth + 1;

				urlObject.parentUrlId = parentUrl.id;
			}

			return urlObject;
		});
	}
};